SEM_DESTROY(3)

NAME
sem_destroy - destroy an unnamed semaphore

LIBRARY
libc_r

SYNOPSIS
#include <semaphore.h>
int
sem_destroy(sem_t *sem);

DESCRIPTION
The sem_destroy() function destroys the unnamed semaphore pointed to by sem. After a successful call to sem_destroy(), sem is unuseable until re-initialized by another call to sem_init().

RETURN VALUES
If successful, sem_destroy() returns 0. Otherwise, -1 is returned and errno is set to indicate the type of error.

ERRORS
sem_destroy() will fail if:

[EINVAL]
    sem points to an invalid semaphore.

[EBUSY]
    There are currently threads blocked on the semaphore that sem points to.

SEE ALSO
sem_init(3)

STANDARDS
sem_destroy() conforms to ISO/IEC 9945-1 ANSI/IEEE (“POSIX”) Std 1003.1 1996 Edition.

POSIX does not define the behavior of sem_destroy() if called while there are threads blocked on sem, but this implementation is guaranteed to return -1 and set errno to EBUSY if there are threads blocked on sem.